

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                                                 SETTERS                                                                                                      ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- set if plague is active
function setActive(ply, cmd, args)
	local txt = {}
	txt[1] = "ON"
	txt[0] = "OFF"
	-- can player modify it
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end  
	
	-- if properly formated, set, otherwise demonstrate use
	if boolArgCheck(args) then
		SetGlobalInt("plague_active", tonumber(args[1]))
		plagueUpdate()
	elseif #args == 0 then
		local tmp = GetGlobalInt("plague_active")
		if tmp == 1 then SetGlobalInt("plague_active", 0)
		else SetGlobalInt("plague_active", 1) end
		
		plagueUpdate()
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - plague_active [0/1] where 1 is true")
	end
end

--- set type of spawn
function setTypeCmd(ply, cmd, args)
	-- can player modify it
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if typeArgCheck(args) then
		SetGlobalString(cmd, args[1])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " [type] where type is rand, same, fast, plain, or poison")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE,cmd .. ": " .. GetGlobalString(cmd) .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetGlobalString(cmd) .. "\n")
end

--- set who has access
function setAccessCmd(ply, cmd, args)
	-- can player modify it
	if !ply:IsAdmin() then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if accessArgCheck(args) then
		SetGlobalString(cmd, args[1])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " [access] where access is any, admin, or none")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE, cmd .. ": " .. GetGlobalString(cmd) .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetGlobalString(cmd) .. "\n")
end


--- set global bools
function setBoolCmd(ply, cmd, args)
	local txt = {}
	txt[1] = "ON"
	txt[0] = "OFF"
	
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if boolArgCheck(args) then
		SetGlobalInt(cmd, tonumber(args[1]))
	elseif #args == 0 then
		local tmp = GetGlobalInt(cmd)
		if tmp == 1 then SetGlobalInt(cmd, 0)
		else SetGlobalInt(cmd, 1) end
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " [0/1] where 1 is true")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE,cmd .. ": " .. txt[GetGlobalInt(cmd)] .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER,cmd .. ": " .. txt[GetGlobalInt(cmd)] .. "\n")
end

--- set color
function setColorCmd(ply, cmd, args)
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if colorArgCheck(args) then
		ply:ConCommand("pvar_r " .. args[1])
		ply:ConCommand("pvar_g " .. args[2])
		ply:ConCommand("pvar_b " .. args[3])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " [0-255] [0-255] [0-255]")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE,cmd .. ": " .. GetConVarString("pvar_r") .. " " .. GetConVarString("pvar_g") .. " " .. GetConVarString("pvar_b") .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER,cmd .. ": " .. GetConVarString("pvar_r") .. " " .. GetConVarString("pvar_g") .. " " .. GetConVarString("pvar_b") .. "\n")
end

--- set prob
function setProbCmd(ply, cmd, args)
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if probArgCheck(args) then
		ply:ConCommand("pvar_pln " .. args[1])
		ply:ConCommand("pvar_fst " .. args[2])
		ply:ConCommand("pvar_pzn " .. args[3])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " [x] [x] [x] where -1 means does not spawn (note you cannot turn off poison if other two are -1")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE, cmd .. ": " .. GetConVarString("pvar_pln") .. " " .. GetConVarString("pvar_fst") .. " " .. GetConVarString("pvar_pzn") .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetConVarString("pvar_pln") .. " " .. GetConVarString("pvar_fst") .. " " .. GetConVarString("pvar_pzn") .. "\n")
end

--- set num (health)
function setNumCmd(ply, cmd, args)
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if numArgCheck(args) then
		ply:ConCommand("pvar_sent_health " .. args[1])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " x")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE, cmd .. ": " .. GetConVarString("pvar_sent_health") .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetConVarString("pvar_sent_health") .. "\n")
end

-- set float (npcsleep)
function setNumfCmd(ply, cmd, args)
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if numArgCheck(args) then
		ply:ConCommand("pvar_npcsleep " .. args[1])
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " x")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE, cmd .. ": " .. GetConVarString("pvar_npcsleep") .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetConVarString("pvar_npcsleep") .. "\n")
end

-- set strings
function setStringCmd(ply, cmd, args)
	if !allowedToModify(ply) then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		ply:PrintMessage(HUD_PRINTCENTER, "INSUFFICIENT ACCESS")
		return 
	end 
	
	-- if properly formated, set, otherwise demonstrate use
	if #args>0 then
		SetGlobalString(cmd, table.concat(args, " "))
	else
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  proper use - " .. cmd .. " x")
		return
	end
	
	ply:PrintMessage(HUD_PRINTCONSOLE, cmd .. ": " .. GetGlobalString(cmd) .. "\n")
	ply:PrintMessage(HUD_PRINTCENTER, cmd .. ": " .. GetGlobalString(cmd) .. "\n")
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                                     HELPER FUNCTIONS                                                                                            ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- check if player is allowed to modify settings
function allowedToModify(ply)
	if GetGlobalString("plague_access") == "any" then
		return true
	elseif GetGlobalString("plague_access") == "none" then
		return false
	else
		return ply:IsAdmin()
	end
end


-- load settings
function loadSettings(ply, cmd, args)
	if !ply:IsAdmin() then 
		ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  you do not have access to this command")
		return 
	end 
	
	local path = args[1]
	
	if path == "default" then
		path = "../cfg/plague_defaults.txt"
	else
		if !args[1] then
			path = "plague_userdefault.txt"
	
		if #args > 1 then
			ply:PrintMessage(HUD_PRINTCONSOLE, "Error:  too many args")
			return
		end
	
		elseif !string.find(path,".txt") then
			path = path .. ".txt"
		end
	
		if !string.find(path,"plague_") then
			path = "plague_" .. path
		end
	end
		
	local f = file.Read(path)
	-- otherwise default
	if !f then
		ply:PrintMessage(HUD_PRINTCONSOLE, "Invalid path\n")
		return
	end
	
	readData(f)
	
	ply:PrintMessage(HUD_PRINTCONSOLE, "Settings Loaded\n")
	ply:PrintMessage(HUD_PRINTCENTER, "Settings Loaded\n")
	plagueUpdate()
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                                        ARG CHECKS                                                                                                    ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- vaild bool arguments
function boolArgCheck(args)
	return #args == 1 && (tonumber(args[1])==1 || tonumber(args[1])==0)
end

function numArgCheck(args)
	return #args == 1 && type(tonumber(args[1])) == "number"
end

--  valid inputs for type
function typeArgCheck(args)
	return #args == 1 && table.HasValue(typeAutoComplete(), args[1])
end

-- valid inputs for access
function accessArgCheck(args)
	return #args == 1 && table.HasValue(accessAutoComplete(), args[1])
end

-- valid color args
function colorArgCheck(args)
	return (#args == 3 && 
	(tonumber(args[1])>=0 && tonumber(args[1])<=255) &&
	(tonumber(args[2])>=0 && tonumber(args[2])<=255) &&
	(tonumber(args[3])>=0 && tonumber(args[3])<=255))
end

-- valid prob args
function probArgCheck(args)
	return (#args == 3 && 
	tonumber(args[1])>=-1 &&
	tonumber(args[2])>=-1 &&
	tonumber(args[3])>=-1)
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                          AUTOCOMPLETE  FUNCTIONS                                                                                       ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function boolAutoComplete() 
	return {"0", "1"}
end

function typeAutoComplete() 
	return {"rand", "same", "plain", "fast", "poison"}
end

function accessAutoComplete() 
	return {"any", "admin", "none"}
end

function colorAutoComplete() 
	return {"r g b"}
end

function probAutoComplete() 
	return {"plain fast poison"}
end

function healthAutoComplete() 
	return {tostring(GetGlobalInt("plague_sent_health"))}
end

function loadAutoComplete() 
	return { "default" , "userdefault"}
end

function sleepAutoComplete() 
	return {tostring(GetGlobalFloat("plague_npcsleep"))}
end

function stringAutoComplete()
	return {"type a new phrase"}
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                                  ANTIVIRUS  FUNCTION                                                                                            ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function antivirus()
	if(!SERVER) then return end

	notify(GetGlobalString("plague_msg_anti"), "birds/birdchirps.wav")  -- let everyone know
	
	-- get all zombies
	local zmbs = ents.FindByClass("npc_zombie*")
	local fast = ents.FindByClass("npc_fastzombie")
	local pzn  = ents.FindByClass("npc_poisonzombie")
	
	-- get headcrabs if needed
	local hc = {}
	if GetGlobalInt("plague_headcrabs") == 1 then
		hc = ents.FindByClass("npc_headcrab*")
	end
	
	-- kill by fire
	for k, ent in pairs(zmbs) do
		ent:Ignite(10000,0)
	end
	for k, ent in pairs(fast) do
		ent:Ignite(10000,0)
	end
	for k, ent in pairs(pzn) do
		ent:Ignite(10000,0)
	end
	for k, ent in pairs(hc) do
		ent:Ignite(10000,0)
	end

	-- turn plague off
	SetGlobalInt("plague_active", 0)
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------                                                                 CONSOLE COMMANDS                                                                                             ---------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------

concommand.Add("plague_active",		setActive, boolAutoComplete)

concommand.Add("plague_headcrabs",	setBoolCmd, boolAutoComplete)
concommand.Add("plague_notify",		setBoolCmd, boolAutoComplete)
concommand.Add("plague_particles",	setBoolCmd, boolAutoComplete)

concommand.Add("plague_msg_on",			setStringCmd, stringAutoComplete)
concommand.Add("plague_msg_off",		setStringCmd, stringAutoComplete)
concommand.Add("plague_msg_anti",		setStringCmd, stringAutoComplete)

concommand.Add("plague_sent_activetoggle",	setBoolCmd, boolAutoComplete)
concommand.Add("plague_sent_antivirus",		setBoolCmd, boolAutoComplete)
concommand.Add("plague_sent_health",		setNumCmd, healthAutoComplete)

concommand.Add("plague_color",		setColorCmd, colorAutoComplete)
concommand.Add("plague_prob",		setProbCmd,  probAutoComplete)

concommand.Add("plague_type",		setTypeCmd,   typeAutoComplete)
concommand.Add("plague_access",		setAccessCmd, accessAutoComplete)

concommand.Add("plague_antivirus",	antivirus)
concommand.Add("plague_load",		loadSettings, loadAutoComplete)

concommand.Add("plague_npcsleep",	setNumfCmd, sleepAutoComplete)
