

if CLIENT then
	-- create panel vars

	local function mainConrols(Panel)
	
		Panel:ClearControls()
		Panel:AddHeader()
		
		local params = {}
		params.Text = "PLAGUE CONTROLS"
		params.Description = "The main plague controls"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Access"
		params.Description = "Who has access to change these settings"
		params.MenuButton = "0"
		params.Options = {}
		params.Options["Anyone"] = { plague_access = "any" }
		params.Options["Admin Only"] = { plague_access = "admin" }
		params.Options["None"] = { plague_access = "none" }
		Panel:AddControl("ComboBox", params)
		
		local params = {}
		params.Label = "Enable Plague"
		params.Description = "Enable/Disable The Plague (zombies make more zombies)"
		params.Command = "plague_active"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)
				
		local params = {}
		params.Label = "Player Notifications"
		params.Description = "Notify all players of plague state"
		params.Command = "plague_notify"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "Use Antivirus"
		params.Description = "Kill all carriers"
		params.Command = "plague_antivirus"
		params.Text = "Activate"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Text = "PLAYER NOTIFICATIONS"
		params.Description = "Messages sent to player when plague state changes"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Plague On Message"
		params.Description = "The message players see when the plague is turned on"
		params.Command = "plague_msg_on"
		params.WaitForEnter = "1"
		Panel:AddControl("TextBox", params)
		
		local params = {}
		params.Label = "Plague Off Message"
		params.Description = "The message players see when the plague is turned off"
		params.Command = "plague_msg_off"
		params.WaitForEnter = "1"
		Panel:AddControl("TextBox", params)
		
		local params = {}
		params.Label = "Antivirus Message"
		params.Description = "The message players see when antivirus is activated"
		params.Command = "plague_msg_anti"
		params.WaitForEnter = "1"
		Panel:AddControl("TextBox", params)
		
		local params = {}
		params.Text = "SAVE"
		params.Description = "Controls to save/load settings"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Save User Settings"
		params.Description = "Save current settings to user default"
		params.Command = "plague_save"
		params.Text = "Save"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "Filepath"
		params.Description = "Save to filepath"
		params.Command = "pvar_savefile"
		Panel:AddControl( "TextBox", params)
		
		local params = {}
		params.Label = ""
		params.Command = "pvar_save"
		params.Text = "Save"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Text = "LOAD"
		params.Description = "Controls to save/load settings"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Load User Settings"
		params.Description = "Load user default settings"
		params.Command = "plague_load userdefault"
		params.Text = "Load"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "Load Default"
		params.Description = "Load default settings"
		params.Command = "plague_load default"
		params.Text = "Load"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "Filepath"
		params.Description = "Load filepath"
		params.Command = "pvar_loadfile"
		Panel:AddControl( "TextBox", params)
		
		local params = {}
		params.Label = ""
		params.Command = "pvar_load"
		params.Text = "Load"
		Panel:AddControl( "Button", params)
	end
	
	local function zombieConrols(Panel)
	
		Panel:ClearControls()
		Panel:AddHeader()
		
		local params = {}
		params.Text = "ZOMBIE CONTROLS"
		params.Description = "Zombie Spawn Settings"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Spawn Type"
		params.Description = "Sets how zombies spawn"
		params.MenuButton = "0"
		params.Options = {}
		params.Options["Random"] = { plague_type = "rand" }
		params.Options["Same as Killer"] = { plague_type = "same" }
		params.Options["Normal Zombie"] = { plague_type = "same" }
		params.Options["Fast Zombie"] = { plague_type = "fast" }
		params.Options["Poison Zombie"] = { plague_type = "poison" }
		Panel:AddControl("ComboBox", params)
		
		local params = {}
		params.Label = "Headcrabs spread plague"
		params.Description = "Enable/Disable headcrabs as carriers"
		params.Command = "plague_headcrabs"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "NPC Sleeptime"
		params.Description = "How long the dead NPC lays before becoming zombie"
		params.Command = "pvar_npcsleep"
		params.Type = "Float"
		params.Min = "0"
		params.Max = "20"
		Panel:AddControl( "Slider", params)
		
		local params = {}
		params.Text = "Probability"
		params.Description = "Zombie Spawn Random probability settings"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Normal Zombie"
		params.Description = "Percentage of normal zombie"
		params.Command = "pvar_pln"
		params.Type = "Int"
		params.Min = "0"
		params.Max = "10"
		Panel:AddControl( "Slider", params)
		
		local params = {}
		params.Label = "Fast Zombie"
		params.Description = "Percentage of fast zombie"
		params.Command = "pvar_fst"
		params.Type = "Int"
		params.Min = "0"
		params.Max = "10"
		Panel:AddControl( "Slider", params)
		
		local params = {}
		params.Label = "Poison Zombie"
		params.Description = "Percentage of poison zombie"
		params.Command = "pvar_pzn"
		params.Type = "Int"
		params.Min = "0"
		params.Max = "10"
		Panel:AddControl( "Slider", params)
		
	end
	
	local function graphicsConrols(Panel)
		Panel:ClearControls()
		Panel:AddHeader()

		local params = {}
		params.Label = "PARTICLES CONTROLS"
		params.Description = "Zombie Spawn Cloud Controls"
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Particles"
		params.Description = "Enable/Disable zombie spawn particles"
		params.Command = "plague_particles"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)

		local params = {}
		params.Label = "Particle Color"
		params.Description = "Set the color of the zombie spawn cloud"
		params.Red = "pvar_r"
		params.Green = "pvar_g"
		params.Blue = "pvar_b"
		params.ShowAlpha = "0"
		params.ShowHSV = "1"
		params.ShowRGB = "1"
		params.Multiplier = "255"
		Panel:AddControl("Color", params)
	end
	
	local function sentConrols(Panel)
	
		Panel:ClearControls()
		Panel:AddHeader()

		local params = {}
		params.Text = "SENT CONTROLS"
		params.Description = "Controls for SENT"		
		Panel:AddControl( "Header", params)
		
		local params = {}
		params.Label = "Allow toggle Plague"
		params.Description = "Can activate/deactivate Plague"
		params.Command = "plague_sent_activetoggle"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "Allow antivirus"
		params.Description = "When damaged, activates antivirus"
		params.Command = "plague_sent_antivirus"
		params.Text = "Toggle"
		Panel:AddControl( "Button", params)
		
		local params = {}
		params.Label = "SENT Health"
		params.Description = "How much damage the SENT can take"
		params.Command = "pvar_sent_health"
		params.Type = "Int"
		params.Min = "100"
		params.Max = "500"
		Panel:AddControl( "Slider", params)

	end
	
	local function addCategory()
        spawnmenu.AddToolCategory( "Options", "Plague", "Plague")
    end
	
	hook.Add( "AddToolMenuCategories", "plague_category", addCategory )
	
	local function createMenu()
        spawnmenu.AddToolMenuOption( "Options", "Plague", "Main", "Main",  "",    "",    mainConrols )
		spawnmenu.AddToolMenuOption( "Options", "Plague", "Zombie", "Zombie",  "",    "",    zombieConrols )
		spawnmenu.AddToolMenuOption( "Options", "Plague", "Particles", "Particles",  "",    "",    graphicsConrols )
		spawnmenu.AddToolMenuOption( "Options", "Plague", "SENT", "SENT",  "",    "",    sentConrols )
    end
		
	hook.Add( "PopulateToolMenu", "create_plague_menu", createMenu )
end



